2 # This Makefile fragment is shared between the coreutils,
3 # CPPI, Bison, and Autoconf.
5 ## Copyright (C) 2001-2006 Free Software Foundation, Inc.
7 ## This program is free software; you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation; either version 2, or (at your option)
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program; if not, write to the Free Software
19 ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
22 # This is reported not to work with make-3.79.1
23 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
26 # Do not save the original name or timestamp in the .tar.gz file.
27 # Use --rsyncable if available.
29 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
30 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
36 CVS_LIST = build-aux/vc-list-files
39 $(CVS_LIST) | if test -f .x-$@; then grep -vEf .x-$@; else grep -v ChangeLog; fi
41 ifeq ($(origin prev_version_file), undefined)
42 prev_version_file = .prev-version
45 PREV_VERSION := $(shell cat $(prev_version_file))
46 VERSION_REGEXP = $(subst .,\.,$(VERSION))
48 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
49 tag-this-version = $(subst .,_,$(VERSION))
50 this-vc-tag = $(tag-package)-$(tag-this-version)
51 my_distdir = $(PACKAGE)-$(VERSION)
53 # Old releases are stored here.
54 # Used for diffs and xdeltas.
55 release_archive_dir ?= ../release
57 # Prevent programs like 'sort' from considering distinct strings to be equal.
58 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
67 # FIXME: add a check to prohibit definition in src/*.c of symbols defined
68 # in system.h. E.g. today I removed from tail.c a useless definition of
69 # ENOSYS. It was useless because system.h ensures it's defined.
71 # Checks that don't require cvs.
72 # Run `changelog-check' last, as previous test may reveal problems requiring
73 # new ChangeLog entries.
74 local-checks-available = \
75 po-check copyright-check writable-files m4-check author_mark_check \
76 changelog-check patch-check strftime-check $(syntax-check-rules) \
77 makefile_path_separator_check \
78 makefile-check check-AUTHORS
79 .PHONY: $(local-checks-available)
81 local-check = $(filter-out $(local-checks-to-skip), $(local-checks-available))
83 # Collect the names of rules starting with `sc_'.
84 syntax-check-rules := $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(ME))
85 .PHONY: $(syntax-check-rules)
87 syntax-check: $(syntax-check-rules)
88 # @grep -nE '# *include <(limits|std(def|arg|bool))\.h>' \
89 # $$(find -type f -name '*.[chly]') && \
90 # { echo '$(ME): found conditional include' 1>&2; \
93 # grep -nE '^# *include <(string|stdlib)\.h>' \
94 # $(srcdir)/{lib,src}/*.[chy] && \
95 # { echo '$(ME): FIXME' 1>&2; \
97 # FIXME: don't allow `#include .strings\.h' anywhere
99 sc_cast_of_argument_to_free:
100 @grep -nE '\<free \(\(' $(srcdir)/{lib,src}/*.[chly] && \
101 { echo '$(ME): don'\''t cast free argument' 1>&2; \
104 sc_cast_of_x_alloc_return_value:
105 @grep -nE --exclude=$(srcdir)/lib/xalloc.h \
106 --exclude=$(srcdir)/lib/regex.c \
107 '\*\) *x(m|c|re)alloc\>' \
108 $(srcdir)/{lib,src}/*.[chy] && \
109 { echo '$(ME): don'\''t cast x*alloc return value' 1>&2; \
112 sc_cast_of_alloca_return_value:
113 @grep -nE '\*\) *alloca\>' \
114 $(srcdir)/src/*.[chy] && \
115 { echo '$(ME): don'\''t cast alloca return value' 1>&2; \
119 @grep -n '[ ] ' $$($(CVS_LIST_EXCEPT)) && \
120 { echo '$(ME): found SPACE-TAB sequence; remove the SPACE' \
123 # Don't use the old ato* functions in `real' code.
124 # They provide no error checking mechanism.
125 # Instead, use strto* functions.
126 sc_prohibit_atoi_atof:
127 @grep -nE '\<ato([filq]|ll)\>' $$($(CVS_LIST_EXCEPT)) && \
128 { echo '$(ME): do not use ato''f, ato''i, ato''l, ato''ll, or ato''q' \
131 # Using EXIT_SUCCESS as the first argument to error is misleading,
132 # since when that parameter is 0, error does not exit. Use `0' instead.
133 sc_error_exit_success:
134 @grep -nF 'error (EXIT_SUCCESS,' \
135 $$(find -type f -name '*.[chly]') && \
136 { echo '$(ME): found error (EXIT_SUCCESS' 1>&2; \
140 @grep -ni 'file''system' $$($(CVS_LIST_EXCEPT)) && \
141 { echo '$(ME): found use of "file''system";' \
142 'rewrite to use "file system"' 1>&2; \
146 @grep -n 'HAVE''_CONFIG_H' $$($(CVS_LIST_EXCEPT)) && \
147 { echo '$(ME): found use of HAVE''_CONFIG_H; remove' \
150 # Nearly all .c files must include <config.h>.
152 @if $(CVS_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
153 grep -L '^# *include <config\.h>' \
154 $$($(CVS_LIST_EXCEPT) | grep '\.c$$') \
156 { echo '$(ME): the above files do not include <config.h>' \
157 1>&2; exit 1; } || :; \
161 # Prohibit the inclusion of assert.h without an actual use of assert.
162 sc_prohibit_assert_without_use:
163 @if $(CVS_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
164 files=$$(grep -l '# *include <assert\.h>' \
165 $$($(CVS_LIST_EXCEPT) | grep '\.c$$')) && \
166 grep -L '\<assert (' $$files \
168 { echo "$(ME): the above files include <assert.h> but don't use it" \
169 1>&2; exit 1; } || :; \
174 @grep -nE '\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
175 $$($(CVS_LIST_EXCEPT)) && \
176 { echo '$(ME): do not use HAVE''_FCNTL_H or O''_NDELAY' \
179 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
181 # Each nonempty line must start with a year number, or a TAB.
183 @grep -n '^[^12 ]' $$(find . -maxdepth 2 -name ChangeLog) && \
184 { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2; \
187 # Ensure that dd's definition of LONGEST_SYMBOL stays in sync
188 # with the strings from the two affected variables.
189 dd_c = $(srcdir)/src/dd.c
190 sc_dd_max_sym_length:
191 ifneq ($(wildcard $(dd_c)),)
192 @len=$$( (sed -n '/conversions\[\] =$$/,/^};/p' $(dd_c);\
193 sed -n '/flags\[\] =$$/,/^};/p' $(dd_c) ) \
194 |sed -n '/"/s/^[^"]*"\([^"]*\)".*/\1/p' \
195 | wc --max-line-length); \
196 max=$$(sed -n '/^#define LONGEST_SYMBOL /s///p' $(dd_c) \
197 |tr -d '"' | wc --max-line-length); \
198 if test "$$len" = "$$max"; then :; else \
199 echo 'dd.c: LONGEST_SYMBOL is not longest' 1>&2; \
204 # Many m4 macros names once began with `jm_'.
205 # On 2004-04-13, they were all changed to start with gl_ instead.
206 # Make sure that none are inadvertently reintroduced.
207 sc_prohibit_jm_in_m4:
208 @grep -nE 'jm_[A-Z]' \
209 $$($(CVS_LIST) m4 |grep '\.m4$$'; echo /dev/null) && \
210 { echo '$(ME): do not use jm_ in m4 macro names' \
214 @t1=sc-root.expected; t2=sc-root.actual; \
215 grep -nl '^PRIV_CHECK_ARG=require-root' \
216 $$($(CVS_LIST) tests) |sed s,tests,., |sort > $$t1; \
217 sed -n 's, cd \([^ ]*\) .*MAKE..check TESTS=\(.*\),./\1/\2,p' \
218 $(srcdir)/tests/Makefile.am |sort > $$t2; \
219 diff -u $$t1 $$t2 || diff=1; \
222 && { echo 'tests/Makefile.am: missing check-root action'>&2; \
225 headers_with_interesting_macro_defs = \
236 # Create a list of regular expressions matching the names
237 # of macros that are guaranteed by parts of gnulib to be defined.
239 @(cd $(srcdir)/lib; \
240 for f in $(headers_with_interesting_macro_defs); do \
242 sed -n '/^# *define \([^_ (][^ (]*\)[ (].*/s//\1/p' $$f; \
245 | grep -Ev 'ATTRIBUTE_NORETURN|SIZE_MAX' \
246 | sed 's/^/^# *define /' \
250 # Don't define macros that we already get from gnulib header files.
251 sc_always_defined_macros: .re-defmac
252 @if test -f $(srcdir)/src/system.h; then \
253 trap 'rc=$$?; rm -f .re-defmac; exit $$rc' 0 1 2 3 15; \
254 grep -f .re-defmac $$($(CVS_LIST)) \
255 && { echo '$(ME): define the above via some gnulib .h file' \
256 1>&2; exit 1; } || :; \
259 # Create a list of regular expressions matching the names
260 # of files included from system.h. Exclude a couple.
262 @sed -n '/^# *include /s///p' $(srcdir)/src/system.h \
263 | grep -Ev 'sys/(param|file)\.h' \
264 | sed 's/ .*//;;s/^["<]/^# *include [<"]/;s/\.h[">]$$/\\.h[">]/' \
268 # Files in src/ should not include directly any of
269 # the headers already included via system.h.
270 sc_system_h_headers: .re-list
271 @if test -f $(srcdir)/src/system.h; then \
272 trap 'rc=$$?; rm -f .re-list; exit $$rc' 0 1 2 3 15; \
273 grep -nE -f .re-list \
274 $$($(CVS_LIST) src | \
275 grep -Ev '((copy|system)\.h|parse-gram\.c)$$') \
276 && { echo '$(ME): the above are already included via system.h'\
277 1>&2; exit 1; } || :; \
282 'solaris[^[:alnum:]]*2\.(7|8|9|[1-9][0-9])|sunos[^[:alnum:]][6-9]' \
283 $$($(CVS_LIST_EXCEPT)) && \
284 { echo '$(ME): found misuse of Sun OS version numbers' 1>&2; \
288 @grep -ni '\<the ''the\>' $$($(CVS_LIST_EXCEPT)) && \
289 { echo '$(ME): found use of "the ''the";' 1>&2; \
296 @grep -n '[ ]$$' $$($(CVS_LIST_EXCEPT)) && \
297 { echo '$(ME): found trailing blank(s)' \
300 # Match lines like the following, but where there is only one space
301 # between the options and the description:
302 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
303 longopt_re = --[a-z][0-9A-Za-z-]*(\[=[0-9A-Za-z-]*\])?
304 sc_two_space_separator_in_usage:
305 @grep -nE '^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
306 $$($(CVS_LIST_EXCEPT)) && \
307 { echo "$(ME): help2man requires at least two spaces between"; \
308 echo "$(ME): an option and its description"; \
311 # Look for diagnostics that aren't marked for translation.
312 # This won't find any for which error's format string is on a separate line.
313 sc_unmarked_diagnostics:
315 '\<error \([^"]*"[^"]*[a-z]{3}' $$($(CVS_LIST_EXCEPT)) \
316 | grep -v '_''(' && \
317 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
320 # Avoid useless parentheses like those in this example:
321 # #if defined (SYMBOL) || defined (SYM2)
322 sc_useless_cpp_parens:
323 @grep -n '^# *if .*defined *(' $$($(CVS_LIST_EXCEPT)) && \
324 { echo '$(ME): found useless parentheses in cpp directive' \
327 # Ensure that the c99-to-c89 patch applies cleanly.
329 rm -rf src-c89 $@.1 $@.2
331 (cd src-c89; patch -V never --fuzz=0) < src/c99-to-c89.diff \
333 grep -v '^patching file ' $@.1 > $@.2 || :
334 if test "$${REGEN_PATCH+set}" = set; then \
335 diff -upr src src-c89 > new-diff || : ; fi
336 fail=0; test -s $@.2 && fail=1 || : ; \
337 rm -rf src-c89 $@.1 $@.2; \
340 # Ensure that date's --help output stays in sync with the info
341 # documentation for GNU strftime. The only exception is %N,
342 # which date accepts but GNU strftime does not.
343 extract_char = sed 's/^[^%][^%]*%\(.\).*/\1/'
345 if test -f $(srcdir)/src/date.c; then \
346 grep '^ %. ' $(srcdir)/src/date.c | sort \
347 | $(extract_char) > $@-src; \
349 info libc date calendar format | grep '^ `%.'\' \
350 | $(extract_char); } | sort > $@-info; \
351 diff -u $@-src $@-info || exit 1; \
352 rm -f $@-src $@-info; \
358 # Ensure that we use only the standard $(VAR) notation,
359 # not @...@ in Makefile.am, now that we can rely on automake
360 # to emit a definition for each substituted variable.
362 grep -nE '@[A-Z_0-9]+@' `find . -name Makefile.am` \
363 && { echo 'Makefile.maint: use $$(...), not @...@' 1>&2; exit 1; } || :
365 news-date-check: NEWS
366 today=`date +%Y-%m-%d`; \
367 if head NEWS | grep '^\*.* $(VERSION_REGEXP) ('$$today')' \
371 echo "version or today's date is not in NEWS" 1>&2; \
376 if head ChangeLog | grep 'Version $(VERSION_REGEXP)\.$$' \
380 echo "$(VERSION) not in ChangeLog" 1>&2; \
385 @grep -n 'AC_DEFUN([^[]' m4/*.m4 \
386 && { echo 'Makefile.maint: quote the first arg to AC_DEFUN' 1>&2; \
389 # Verify that all source files using _() are listed in po/POTFILES.in.
390 # FIXME: don't hard-code file names below; use a more general mechanism.
392 if test -f po/POTFILES.in; then \
393 grep -E -v '^(#|$$)' po/POTFILES.in \
394 | grep -v '^src/false\.c$$' | sort > $@-1; \
396 for file in $$($(CVS_LIST_EXCEPT)) lib/*.[ch]; do \
398 djgpp/* | man/*) continue;; \
402 base=`expr " $$file" : ' \(.*\)\..'`; \
403 { test -f $$base.l || test -f $$base.y; } && continue;; \
405 files="$$files $$file"; \
407 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
409 diff -u $@-1 $@-2 || exit 1; \
413 # In a definition of #define AUTHORS "... and ..." where the RHS contains
414 # the English word `and', the string must be marked with `N_ (...)' so that
415 # gettext recognizes it as a string requiring translation.
417 @grep -n '^# *define AUTHORS "[^"]* and ' src/*.c |grep -v ' N_ (' && \
418 { echo 'Makefile.maint: enclose the above strings in N_ (...)' 1>&2; \
421 # Sometimes it is useful to change the PATH environment variable
422 # in Makefiles. When doing so, it's better not to use the Unix-centric
423 # path separator of `:', but rather the automake-provided `@PATH_SEPARATOR@'.
424 # It'd be better to use `find -print0 ...|xargs -0 ...', but less portable,
425 # and there probably aren't many projects with so many Makefile.am files
426 # that we'd have to worry about limits on command line length.
427 msg = 'Makefile.maint: Do not use `:'\'' above; use @PATH_SEPARATOR@ instead'
428 makefile_path_separator_check:
429 @grep -n 'PATH=.*:' `find $(srcdir) -name Makefile.am` \
430 && { echo $(msg) 1>&2; exit 1; } || :
432 # Check that `make alpha' will not fail at the end of the process.
434 if test -d $(release_archive_dir); then :; else \
435 mkdir $(release_archive_dir); \
437 for file in $(distdir).tar.gz $(xd-delta) \
438 $(release_archive_dir)/$(distdir).tar.gz \
439 $(release_archive_dir)/$(xd-delta); do \
440 test -e $$file || continue; \
442 || { echo ERROR: $$file is not writable; fail=1; }; \
444 test "$$fail" && exit 1 || :
446 v_etc_file = lib/version-etc.c
447 # Make sure that the copyright date in $(v_etc_file) is up to date.
449 @if test -f $(v_etc_file); then \
450 grep 'enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' $(v_etc_file) \
452 || { echo 'out of date copyright in $(v_etc_file); update it' 1>&2; \
457 # Sanity checks with the repository.
458 # Abort early if this tag has already been used.
461 if $(VC) --help | grep CVS; then \
462 $(CVS) -n log -h README|grep -e $(this-vc-tag): >/dev/null \
465 $(GIT) tag -l '^$(this-vc-tag)$$' && used=yes; \
467 if test "$$used" = yes; then \
468 echo "$(this-vc-tag) has already been used; not tagging" 1>&2; \
473 $(VC) diff > vc-diffs || :
474 if test -s vc-diffs; then \
476 echo "Some files are locally modified:" 1>&2; \
482 cvs-check: vc-diff-check vc-tag-check
484 maintainer-distcheck:
489 # Tag before making distribution. Also, don't make a distribution if
490 # checks fail. Also, make sure the NEWS file is up-to-date.
491 # FIXME: use dist-hook/my-dist like distcheck-hook/my-distcheck.
492 vc-dist: $(local-check) cvs-check maintainer-distcheck
493 $(VC) tag $(this-vc-tag)
496 # Use this to make sure we don't run these programs when building
497 # from a virgin tgz file, below.
498 null_AM_MAKEFLAGS = \
505 # Detect format-string/arg-list mismatches that would normally be obscured
506 # by the use of _(). The --disable-nls effectively defines away that macro,
507 # and building with CFLAGS='-Wformat -Werror' causes any format warning to be
508 # treated as a failure. Also, check for shadowing problems with -Wshadow,
509 # and for pointer arithmetic problems with -Wpointer-arith.
510 # These CFLAGS are pretty strict. If you build this target, you probably
511 # have to have a recent version of gcc and glibc headers.
513 t=$(TMPDIR)/$(PACKAGE)/test
514 my-distcheck: $(local-check) $(release_archive_dir)/$(prev-tgz)
517 GZIP=$(GZIP_ENV) $(AMTAR) -C $(t) -zxf $(distdir).tar.gz
519 && ./configure --disable-nls \
520 && $(MAKE) CFLAGS='-Werror -Wall -Wformat -Wshadow -Wpointer-arith' \
521 AM_MAKEFLAGS='$(null_AM_MAKEFLAGS)' \
525 (cd $(t) && mv $(distdir) $(distdir).old \
526 && $(AMTAR) -zxf - ) < $(distdir).tar.gz
527 diff -ur $(t)/$(distdir).old $(t)/$(distdir)
529 @echo "========================"; \
530 echo "$(distdir).tar.gz is ready for distribution"; \
531 echo "========================"
537 tarz=/tmp/rel-check-tarz-$$$$; \
538 md5_tmp=/tmp/rel-check-md5-$$$$; \
540 trap 'status=$$?; rm -f $$tarz $$md5_tmp; exit $$status' 0 1 2 3 15; \
541 $(WGET) $(WGETFLAGS) -q --output-document=$$tarz $(url); \
542 echo "$(md5) -" > $$md5_tmp; \
543 md5sum -c $$md5_tmp < $$tarz
545 prev-tgz = $(PACKAGE)-$(PREV_VERSION).tar.gz
546 xd-delta = $(PACKAGE)-$(PREV_VERSION)-$(VERSION).xdelta
548 rel-files = $(xd-delta) $(DIST_ARCHIVES)
549 announcement: NEWS ChangeLog $(rel-files)
551 --release-type=$(RELEASE_TYPE) \
552 --package=$(PACKAGE) \
553 --prev=$(PREV_VERSION) \
555 --release-archive-directory=$(release_archive_dir) \
556 --gpg-key-id=$(gpg_key_ID) \
558 $(addprefix --url-dir=, $(url_dir_list)) \
561 ## ---------------- ##
562 ## Updating files. ##
563 ## ---------------- ##
565 ftp-gnu = ftp://ftp.gnu.org/gnu
566 www-gnu = http://www.gnu.org
568 # Use mv, if you don't have/want move-if-change.
569 move_if_change ?= move-if-change
571 emit_upload_commands:
572 @echo =====================================
573 @echo =====================================
574 @echo "$(srcdir)/build-aux/gnupload $(GNUPLOADFLAGS) \\"
575 @echo " --to $(gnu_rel_host):coreutils \\"
576 @echo " $(rel-files)"
577 @echo '# send the /tmp/announcement e-mail'
578 @echo =====================================
579 @echo =====================================
581 $(xd-delta): $(release_archive_dir)/$(prev-tgz) $(distdir).tar.gz
582 xdelta delta -9 $^ $@ || :
584 .PHONY: alpha beta major
585 alpha beta major: news-date-check changelog-check $(local-check)
587 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
588 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
592 $(MAKE) -s announcement RELEASE_TYPE=$@ > /tmp/announce-$(my_distdir)
593 ln $(rel-files) $(release_archive_dir)
594 chmod a-w $(rel-files)
595 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
596 echo $(VERSION) > $(prev_version_file)
598 '$(prev_version_file): Record previous version: $(VERSION).' \